#include "log.h"
#include <QDateTime>
#include <QTextStream>

//mode: 0=text+write file on command
Log::Log( QTextEdit *txtLog, QString fileName, int mode=0) 
{
	logText = txtLog;
	this->fileName=fileName;
	logMode=mode;
	QString date = QDateTime::currentDateTime().toString("dddd, dd.MM.yyyy hh:mm:ss");

	text=tr("Starting Log on %1\n").arg(date);
	logText->setReadOnly(true);
	logText->setText(text);
}

void Log::addEntry(QString entry)
{
	entry.insert(0,QDateTime::currentDateTime().toString("[hh:mm] "));
	text.append(entry + "\n");
	logText->append(entry);
	if (logMode==1) saveToFile();
	return;
}

bool Log::saveToFile(QString fName)
{
	if (fName!="") fileName=fName;
	if (fileName==""){
	
		return false;
	}
	return saveToFile();
}

bool Log::saveToFile()
{
	QFile file(fileName);

	if (!file.open(QIODevice::WriteOnly | QIODevice::Text)) return false;
	QTextStream out(&file);
	
	out << text;
	
	return true;
}
