
#include "smtp.h"
//#include <QTextEdit>

Smtp::Smtp()
{
	error = false;
	return;
}

void Smtp::ini(const QString &lsmtpusername, const QString &lsmtppass, const QString &lsmtphost)
{
	newMail=false;
    smtphost = lsmtphost;
    smtpusername =lsmtpusername;
    smtppass = lsmtppass;
   
   run();

}

void Smtp::run()
{
	qDebug()<<"run";

    int waittime = 50 * 1000;
    
    ErrorMSG.clear();
   
    Timeout = waittime;
    linesend = 0;
   
    //qDebug() << "Config server smtp connect to......  "  << smtphost;
    
    QCoreApplication::processEvents();
    
    smtpsocket = new QTcpSocket(this);
    connect( this, SIGNAL(ConnectorSuccess()), this ,SLOT(ReadLiner()));
    connect( this, SIGNAL(SendLine()), this ,SLOT(PutSendLine()));  
    smtpsocket->connectToHost(smtphost,25);
    if (smtpsocket->waitForConnected(Timeout)) {
    	qDebug() <<"connected on  " << smtphost;
        QCoreApplication::processEvents();
         if (smtpsocket->waitForReadyRead(Timeout)) {
          qDebug() <<"emit from waitForReadyRead connect go can read";
          emit ConnectorSuccess();
          }
    } else {
    	qDebug()<<"error";
        emit ErrorCloseAll();
    }

	while(running){
		
	}
	qDebug()<<"end";
}

void Smtp::sendMail(const QString &from, const QString &to, const QStringList &bcc, const QString &subject, QString name="", const QString &bodyHtml="", const QString &bodyPlain="")
{
	if (name=="") name=from;
	newMail=true;
	
	this->from = from;
	this->bcc=bcc;
    rcpt=to;

    message=("");
    message.append("X-Accept-Language: de-ch, de\n");
    message.append("From: "+name+" <" + from + ">\n");
    message.append("To: "+to+"\n");
    if(!bcc.size()==0){
    	QString str=bcc.join(",");
    	//message.append("Bcc: "+str+"\n");    	
   	}
    message.append("Subject: " + subject + "\n");
    message.append(TimeStampMail() + "\n");
    message.append("User-Agent: Newsletter Manager 0.2 (Linux/20070930)\n");
    message.append("MIME-Version: 1.0\n");
    
    if(bodyHtml!="" && bodyPlain!=""){
   		message.append("Content-Type: multipart/alternative; boundary=\"NextPart_000_0015_01C811AF4D294B40\";\n\n");
   		message.append("This is a multi-part message in MIME format.\n\n\n");
   		message.append("--NextPart_000_0015_01C811AF4D294B40\n");
   		message.append("Content-Type: text/html; charset=UTF8;\n"); //alternative: iso-8859-1
   		message.append("Content-transfer-encoding: 7BIT\n\n\n"); //alternative: quoted-printable
    	message.append(bodyHtml);
   		message.append("\n--NextPart_000_0015_01C811AF4D294B40\n");
   		message.append("Content-Type: text/plain; charset=UTF8;\n");
   		message.append("Content-transfer-encoding: 7BIT\n\n\n");
    	message.append(bodyPlain.toAscii());
   		message.append("\n--NextPart_000_0015_01C811AF4D294B40--");    	
   	}else if(bodyHtml==""){
    	message.append("Content-Type: text/plain; charset=UTF8;\n");
    	message.append("Content-transfer-encoding: 7BIT\n\n\n\n");
   		message.append(bodyPlain.toAscii());
   	}else if (bodyPlain==""){
   		message.append("Content-Type: text/html; charset=UTF8;\n");
   		message.append("Content-transfer-encoding: 7BIT\n\n\n\n");
   		message.append(bodyHtml);
  	}    
    
    message.replace( QString::fromLatin1( "\n" ), QString::fromLatin1( "\r\n" ) );
    message.replace( QString::fromLatin1( "\r\n.\r\n" ),QString::fromLatin1( "\r\n..\r\n" ) );

	//qDebug()<<message;

    linesend = 5;
	emit SendLine();
}

void Smtp::disconnectSmtp()
{
	disconnect(this, SIGNAL(ConnectorSuccess()), this ,SLOT(ReadLiner()));
    disconnect(this, SIGNAL(SendLine()), this ,SLOT(PutSendLine()));  
	linesend=10;
	PutSendLine();
	mutex.lock();
	running=false;
	qDebug()<<"set running false";
	mutex.unlock();
}

void Smtp::ReadLiner()
{
        //qDebug() << "### socketType = " << smtpsocket->socketType();
        //qDebug() << "### ReadLiner is start by textstream ";
        t = new QTextStream( smtpsocket );
        int loops = 0;
        while (!t->atEnd()){
        loops++;
        response = t->readLine();
        //qDebug() << loops << " in line  " << response;
        }
        if (response.size() > 0) {
        RemoteServerName = response;
        mailstatus = response.left(3);
        if (mailstatus == "220") {
                response="";
                linesend = 1;
                emit SendLine();
                }
        } else {
           emit ErrorCloseAll();
        }
}

Smtp::~Smtp()

{
    delete t;
    delete smtpsocket;
}

/* LINE SENDER  */
void Smtp::PutSendLine()
{
	static bool rcptSent=false;	
	
    int current = linesend;
    qDebug() <<"### Go and Send line " << linesend;
    switch(current) {
      case 1:
          response = SendLineAndGrab("HELO moschtiwurm\r\n");
           if (response.size() > 0) {
               ErrorMSG.append(response);
               qDebug() << "1---- " << response;
                linesend = 2;
                emit SendLine();
           } else {
                qDebug() << "Connection lost1";
                emit ErrorCloseAll();
           }
          response ="";
      break;
      case 2:
          response = SendLineAndGrab("AUTH LOGIN\r\n");
           if (response.size() > 0) {
           ErrorMSG.append(response);
                qDebug() << "2---- " << response;
                linesend = 3;
                emit SendLine();
           } else {
                qDebug() << "Connection lost2";
                emit ErrorCloseAll();
           }
          response ="";
      break;
      case 3:
          response = SendLineAndGrab(encodeBase64(smtpusername)+"\r\n");   /* username send */
           if (response.size() > 0) {
           ErrorMSG.append(response);
                qDebug() << "3---- " << response;
                linesend = 4;
                emit SendLine();
           } else {
                qDebug() << "Connection lost3";
                emit ErrorCloseAll();
           }
          response ="";
      break;
      case 4:
			response = SendLineAndGrab(encodeBase64(smtppass)+"\r\n");     /* pass send */
			qDebug() << "4---- " << response;
           if (response.size() > 0) {
				ErrorMSG.append(response);
				if (response.contains("successful", Qt::CaseInsensitive)||response.contains("ok", Qt::CaseInsensitive)){
					linesend = 9;
					emit SendLine();                   		
				}else{
				 	qDebug() << "Connection lost4.1";
					emit ErrorCloseAll();               			
				}
           } else {
                qDebug() << "Connection lost4.2";
                emit ErrorCloseAll();
           }
          response ="";
      break;
      case 5:
          //if (!newMail) break;
          response = SendLineAndGrab("MAIL FROM: "+from+"\r\n");
           qDebug() << "5---- " << response;
           if (response.size() > 0) {
                linesend = 6;
                emit SendLine();               
           } else {
                qDebug() << "Connection lost5";
                emit ErrorCloseAll();
           }
         
      break;
      case 6:
          	if (!rcptSent){
	          	response = SendLineAndGrab("RCPT TO: "+rcpt+"\r\n");
	           	qDebug() << "6---- " << response;
				rcptSent=true;			
         	}
           if (response.size() > 0){
           		if(bcc.size()>0){
		        	response = SendLineAndGrab("RCPT TO: "+bcc.takeFirst()+"\r\n");
		        	qDebug() << "6---- " << response;
	                linesend=6;
	                emit SendLine();
          		}
                ErrorMSG.append(response);
                linesend=7;
                emit SendLine();
           } else {
             qDebug() << "Connection lost6.2";
             emit ErrorCloseAll();
           }
          //response ="";
      break;
      case 7:
      	response = SendLineAndGrab("DATA\r\n");
        qDebug() << "7---- " << response;
	       if (!response.contains("not", Qt::CaseInsensitive)) {
	        ErrorMSG.append(response);
	        response ="";             
	        linesend = 8;
	       	emit SendLine();                     
	       } else {
	           qDebug() << "Connection lost7";
	           emit ErrorCloseAll();
	       }
      break;
      case 8:
          response = SendLineAndGrab(message+"\r\n.\r\n");
           qDebug() << "8---- " << response;
           if (response.size() && (response.contains("ok", Qt::CaseInsensitive)||response.contains("accepted", Qt::CaseInsensitive))) {
                ErrorMSG.append(response);
                linesend = 9;
                qDebug() << "Mail to " << rcpt << " successfully sent";
                emit SendLine();               
           } else {
                qDebug() << "Connection lost8";
                emit ErrorCloseAll();
           }
           response ="";
      break;
      case 9:
      	response = SendLineAndGrab("NOOP\r\n");
          qDebug() << "9---- "<<response;
              QCoreApplication::processEvents();
          emit ReadyToSend();
          //qDebug() << "Signal ReadyToSend emitted";
          response ="";     
      break;
      case 10:
          response = SendLineAndGrab("QUIT\r\n");
          qDebug() << "10---- " << response;
          ErrorMSG.append(response);
          emit SuccessQuit();
          response ="";
      break;
      default:
      qDebug() << "ERROR!  last loop or false line emit...";
      emit ErrorCloseAll();
      break;
    }   
}

/* SENDER AND RECIVER  */
QString Smtp::SendLineAndGrab(QString senddata)
{
    int loops = 0;
    QString incommingData = "";
    //qDebug() << "####Send" << current << "Now => " << senddata;
    *t << senddata;
     t->flush();
          if (smtpsocket->waitForReadyRead(Timeout)) {
          			
          			QCoreApplication::processEvents();
                    while (!t->atEnd()) {
                    loops++;
                    QString opera = t->readLine();
                    if(loops==1)incommingData.append(opera);
                    else incommingData.append("\n"+opera);
                    //qDebug() << loops << "|#" << opera << "#|";
                    }
          }else qDebug()<<smtpsocket->errorString();
return incommingData;
}
 
void Smtp::disconnected()
{
    qDebug() <<"disconneted";
    qDebug() << "error "  << smtpsocket->errorString();
}
void Smtp::connected()
{
    output.append("connected");
    qDebug() << "Connected ";
}

QString Smtp::encodeBase64( QString xml )
{
    QByteArray text;
    text.append(xml);
    return text.toBase64();
}

QString Smtp::decodeBase64( QString xml )
{
    QByteArray xcode("");;
    xcode.append(xml);
    QByteArray precode(QByteArray::fromBase64(xcode));
    QString notetxt = precode.data();
    return notetxt;
}

QString Smtp::TimeStampMail()
{
    /* Date: Mon, 08 May 2006 17:57:52 +0200 */
    /* Date: Sun, 28 May 2006 06:32:25 -0420 */
    QLocale english(QLocale::English,QLocale::UnitedKingdom);
    
    QDateTime dt = QDateTime::currentDateTime();
    QDate timecute = QDate::currentDate();
    QString day_en = english.dayName(timecute.dayOfWeek(),QLocale::ShortFormat);
    QString month_en = english.monthName(timecute.month(),QLocale::ShortFormat);
    QString last = dt.toString("yyyy hh:mm:ss");
    QString maildate = QString( "Date: %1, %2 %3 %4 +0200" ).arg( day_en , QString::number(timecute.day()), month_en ,   last );
    qDebug() << maildate;
return maildate;
}
