#ifndef SMTP_H
#define SMTP_H

#include <QtNetwork>
//#include <QTcpSocket>
#include <QString>
#include <QTextStream>
#include <QDebug>
#include <QMessageBox>
//#include <QAbstractSocket>
#include <QDateTime>
#include <QDate>
#include <QThread>
/*
      USAGE!
      Smtp *newMail  = new Smtp("from@address.com","to@address.com"," Your Subject","My body text");
      class emit ErrorCloseAll() / SuccessQuit()   or get QStringList ErrorMSG; to read error and data....
     
*/

class Smtp : public QThread
{
    Q_OBJECT
   
public:
	Smtp();
    ~Smtp();
    int linesend;
    QStringList ErrorMSG;
    void sendMail(const QString &from, const QString &to, const QStringList &bcc, const QString &subject, QString name, const QString &bodyHtml, const QString &bodyPlain);
    void disconnectSmtp();
    void ini(const QString &lsmtpusername, const QString &lsmtppassconst, const QString &lsmtphost);
    bool error;
    
protected:
	void run();
 
signals:
    void status( const QString &);
    void ConnectorSuccess();
    void SendLine();
    void ErrorCloseAll();
    void SuccessQuit();
    void ReadyToSend();

private slots:
    void disconnected();
    void connected();
    void ReadLiner();
    void PutSendLine();
    
private:
	bool newMail;
    QString smtpusername;
    QString smtppass;
    QString smtphost;
    QString message;
    QString output;
    QString RemoteServerName;
    QString mailstatus;
    QTextStream *t;
    QTcpSocket *smtpsocket;
    QString from;
    QStringList bcc;
    QString rcpt;
    QString response;
    QString SendLineAndGrab(QString senddata);
    int Timeout;
    QString encodeBase64( QString xml );
    QString decodeBase64( QString xml );
    QString TimeStampMail();
    bool running;
    QMutex mutex;
};

#endif
